/*-
 * Copyright (C)2004..2024 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: stub.c,v 1.8 2024/11/03 18:08:22 babolo Exp $
 */

#ident "@(#) Copyright (C)2004..2024 @BABOLO http://www.babolo.ru/"
#ident "@(#) $Id: stub.c,v 1.8 2024/11/03 18:08:22 babolo Exp $"

#include <sysexits.h>
#include <signal.h>
#include <syslog.h>
#include <stdarg.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

static char const *signames[] =
{ "NULL", "HUP" , "INT"   , "QUIT", "ILL"  , "TRAP", "ABRT", "EMT"
, "FPE" , "KILL", "BUS"   , "SEGV", "SYS"  , "PIPE", "ALRM", "TERM"
, "URG" , "STOP", "TSTP"  , "CONT", "CHLD" , "TTIN", "TTOU", "IO"
, "XCPU", "XFSZ", "VTALRM", "PROF", "WINCH", "INFO", "USR1", "USR2"
};

static void
sigd(int sig) {
    syslog(LOG_WARNING, "Signal %d=%s", sig, ((sig >= 0) && (sig < 32)) ? signames[sig] : "none");
}

int
main(int argc, char **argv) {
    struct sigaction sa;

    (void)argc;
    (void)argv;
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = SA_NODEFER;
    sa.sa_handler = sigd;
    sigaction(SIGURG  , &sa, NULL);
    sigaction(SIGTSTP , &sa, NULL);
    sigaction(SIGCHLD , &sa, NULL);
    sigaction(SIGTTIN , &sa, NULL);
    sigaction(SIGTTOU , &sa, NULL);
    sigaction(SIGIO   , &sa, NULL);
    sigaction(SIGWINCH, &sa, NULL);
    sigaction(SIGINFO , &sa, NULL);
    while(!sleep(86400 * 365)) {}
    syslog(LOG_WARNING, "Sleep out %d=%m", errno);
    exit(EX_TEMPFAIL);
}
